package com.alanyates.cellularAutomata;

public class CellFactory {
	private System system;
	private Class implementor;
	
	public CellFactory(System system) throws ClassNotFoundException {
		this.system = system;
		this.implementor = Class.forName(system.getParameter("cellImplementor"));
	}
	
	public Cell getNewInstance(int x, int y) throws InstantiationException, IllegalAccessException {
		Cell newCell = (Cell)implementor.newInstance();
		newCell.setPosition(x, y);
		newCell.configure(this.system);
		return newCell;
	}
}
