package com.alanyates.cellularAutomata;

import java.util.Random;

public class ConwayLifeCell implements Cell {
	private static Random random = new Random();

	private int x, y;

	public boolean state;
	private boolean nextState;

	public void setPosition(int x, int y) {
		this.x = x;
		this.y = y;
	}
	
	public void configure(System system) {
		if("true".equals(system.getParameter("setCell(" + this.x + "," + this.y + ")"))) this.state = true;
		if("true".equals(system.getParameter("initRandom"))) this.state = ConwayLifeCell.random.nextBoolean();
//		java.lang.System.out.println("cell(" + this.x + "," + this.y + ") = " + this.state);
	}
	
	public void calculateNextState(System system) {
		int liveCells = 0;
		for(int y = this.y - 1; y < this.y + 2; y++) {
			for(int x = this.x - 1; x < this.x + 2; x++) {
				ConwayLifeCell nc = (ConwayLifeCell)system.cellAt(x, y);
				if(x == this.x && y == this.y) nc = null;
				if(nc != null && nc.state) liveCells++;
			}
		}
		switch(liveCells) {
			case 2:
				this.nextState = this.state;
				break;
			case 3:
				this.nextState = true;
				break;
			default:
				this.nextState = false;
				break;
		}
	}

	public void transitionToNextState(System system) {
		this.state = this.nextState;
	}

	public int getColour() {
		return (this.state)?(0xff0000):(0xffffff);
	}
}
