package com.alanyates.cellularAutomata;

public class OneDimCell implements Cell {
	private int x, y;

	public boolean state;
	private boolean nextState;

	private String rule;
	
	public void setPosition(int x, int y) {
		this.x = x;
		this.y = y;
	}
	
	public void configure(System system) {
		this.rule = system.getParameter("rule");
		if("true".equals(system.getParameter("setCell(" + this.x + "," + this.y + ")"))) this.state = true;
//		java.lang.System.out.println("cell(" + this.x + "," + this.y + ":" + this.rule + ") = " + this.state);
	}
	
	public void calculateNextState(System system) {
		OneDimCell left = (OneDimCell)system.cellAt(x - 1, y);
		boolean l = (left != null)?(left.state):(false);
		OneDimCell right = (OneDimCell)system.cellAt(x + 1, y);
		boolean r = (right != null)?(right.state):(false);
		int idx = ((l)?(4):(0)) + ((this.state)?(2):(0)) + ((r)?(1):(0));
		this.nextState = ('1' == this.rule.charAt(7 - idx));
//		this.nextState = ((!l) && (r || this.state)) || (l && !(r || this.state));
	}

	public void transitionToNextState(System system) {
		this.state = this.nextState;
	}

	public int getColour() {
		return (this.state)?(0xff0000):(0xffffff);
	}
}
